<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCustomerListWithTroubleConditions ArrayType
 * @subpackage Arrays
 */
class ArrayOfCustomerListWithTroubleConditions extends AbstractStructArrayBase
{
    /**
     * The CustomerListWithTroubleConditions
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\CustomerListWithTroubleConditions[]
     */
    public $CustomerListWithTroubleConditions;
    /**
     * Constructor method for ArrayOfCustomerListWithTroubleConditions
     * @uses ArrayOfCustomerListWithTroubleConditions::setCustomerListWithTroubleConditions()
     * @param \CustomerManagement\StructType\CustomerListWithTroubleConditions[] $customerListWithTroubleConditions
     */
    public function __construct(array $customerListWithTroubleConditions = array())
    {
        $this
            ->setCustomerListWithTroubleConditions($customerListWithTroubleConditions);
    }
    /**
     * Get CustomerListWithTroubleConditions value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\CustomerListWithTroubleConditions[]|null
     */
    public function getCustomerListWithTroubleConditions()
    {
        return isset($this->CustomerListWithTroubleConditions) ? $this->CustomerListWithTroubleConditions : null;
    }
    /**
     * Set CustomerListWithTroubleConditions value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\CustomerListWithTroubleConditions[] $customerListWithTroubleConditions
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerListWithTroubleConditions
     */
    public function setCustomerListWithTroubleConditions(array $customerListWithTroubleConditions = array())
    {
        foreach ($customerListWithTroubleConditions as $arrayOfCustomerListWithTroubleConditionsCustomerListWithTroubleConditionsItem) {
            // validation for constraint: itemType
            if (!$arrayOfCustomerListWithTroubleConditionsCustomerListWithTroubleConditionsItem instanceof \CustomerManagement\StructType\CustomerListWithTroubleConditions) {
                throw new \InvalidArgumentException(sprintf('The CustomerListWithTroubleConditions property can only contain items of \CustomerManagement\StructType\CustomerListWithTroubleConditions, "%s" given', is_object($arrayOfCustomerListWithTroubleConditionsCustomerListWithTroubleConditionsItem) ? get_class($arrayOfCustomerListWithTroubleConditionsCustomerListWithTroubleConditionsItem) : gettype($arrayOfCustomerListWithTroubleConditionsCustomerListWithTroubleConditionsItem)), __LINE__);
            }
        }
        if (is_null($customerListWithTroubleConditions) || (is_array($customerListWithTroubleConditions) && empty($customerListWithTroubleConditions))) {
            unset($this->CustomerListWithTroubleConditions);
        } else {
            $this->CustomerListWithTroubleConditions = $customerListWithTroubleConditions;
        }
        return $this;
    }
    /**
     * Add item to CustomerListWithTroubleConditions value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\CustomerListWithTroubleConditions $item
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerListWithTroubleConditions
     */
    public function addToCustomerListWithTroubleConditions(\CustomerManagement\StructType\CustomerListWithTroubleConditions $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\CustomerListWithTroubleConditions) {
            throw new \InvalidArgumentException(sprintf('The CustomerListWithTroubleConditions property can only contain items of \CustomerManagement\StructType\CustomerListWithTroubleConditions, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CustomerListWithTroubleConditions[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\CustomerListWithTroubleConditions|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\CustomerListWithTroubleConditions|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\CustomerListWithTroubleConditions|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\CustomerListWithTroubleConditions|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\CustomerListWithTroubleConditions|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CustomerListWithTroubleConditions
     */
    public function getAttributeName()
    {
        return 'CustomerListWithTroubleConditions';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfCustomerListWithTroubleConditions
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
