<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfKeyfobKey4Output ArrayType
 * @subpackage Arrays
 */
class ArrayOfKeyfobKey4Output extends AbstractStructArrayBase
{
    /**
     * The KeyfobKey4Output
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\KeyfobKey4Output[]
     */
    public $KeyfobKey4Output;
    /**
     * Constructor method for ArrayOfKeyfobKey4Output
     * @uses ArrayOfKeyfobKey4Output::setKeyfobKey4Output()
     * @param \CustomerManagement\StructType\KeyfobKey4Output[] $keyfobKey4Output
     */
    public function __construct(array $keyfobKey4Output = array())
    {
        $this
            ->setKeyfobKey4Output($keyfobKey4Output);
    }
    /**
     * Get KeyfobKey4Output value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\KeyfobKey4Output[]|null
     */
    public function getKeyfobKey4Output()
    {
        return isset($this->KeyfobKey4Output) ? $this->KeyfobKey4Output : null;
    }
    /**
     * Set KeyfobKey4Output value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\KeyfobKey4Output[] $keyfobKey4Output
     * @return \CustomerManagement\ArrayType\ArrayOfKeyfobKey4Output
     */
    public function setKeyfobKey4Output(array $keyfobKey4Output = array())
    {
        foreach ($keyfobKey4Output as $arrayOfKeyfobKey4OutputKeyfobKey4OutputItem) {
            // validation for constraint: itemType
            if (!$arrayOfKeyfobKey4OutputKeyfobKey4OutputItem instanceof \CustomerManagement\StructType\KeyfobKey4Output) {
                throw new \InvalidArgumentException(sprintf('The KeyfobKey4Output property can only contain items of \CustomerManagement\StructType\KeyfobKey4Output, "%s" given', is_object($arrayOfKeyfobKey4OutputKeyfobKey4OutputItem) ? get_class($arrayOfKeyfobKey4OutputKeyfobKey4OutputItem) : gettype($arrayOfKeyfobKey4OutputKeyfobKey4OutputItem)), __LINE__);
            }
        }
        if (is_null($keyfobKey4Output) || (is_array($keyfobKey4Output) && empty($keyfobKey4Output))) {
            unset($this->KeyfobKey4Output);
        } else {
            $this->KeyfobKey4Output = $keyfobKey4Output;
        }
        return $this;
    }
    /**
     * Add item to KeyfobKey4Output value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\KeyfobKey4Output $item
     * @return \CustomerManagement\ArrayType\ArrayOfKeyfobKey4Output
     */
    public function addToKeyfobKey4Output(\CustomerManagement\StructType\KeyfobKey4Output $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\KeyfobKey4Output) {
            throw new \InvalidArgumentException(sprintf('The KeyfobKey4Output property can only contain items of \CustomerManagement\StructType\KeyfobKey4Output, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->KeyfobKey4Output[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\KeyfobKey4Output|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\KeyfobKey4Output|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\KeyfobKey4Output|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\KeyfobKey4Output|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\KeyfobKey4Output|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string KeyfobKey4Output
     */
    public function getAttributeName()
    {
        return 'KeyfobKey4Output';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfKeyfobKey4Output
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
